package com.example.soulfood_assignment2;

import android.content.Intent;
import android.os.Bundle;
import android.support.v7.app.AppCompatActivity;
import android.util.Log;
import android.view.View;
import android.widget.ProgressBar;
import android.widget.Toast;

import com.spotify.android.appremote.api.ConnectionParams;
import com.spotify.android.appremote.api.Connector;
import com.spotify.android.appremote.api.SpotifyAppRemote;
import com.spotify.sdk.android.authentication.AuthenticationClient;
import com.spotify.sdk.android.authentication.AuthenticationRequest;
import com.spotify.sdk.android.authentication.AuthenticationResponse;

import java.io.BufferedInputStream;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;

public class MainActivity extends AppCompatActivity {

    private int currentProgress = 0;
    private ProgressBar PBar;
    private int maxValue;
    private int progressValue;

    public static SpotifyClass spotifyClass;
    private static final int REQUEST_CODE = 1337;

    int swipeStartX = -50; //arbitrary default value
    int swipeEndX;
    View sideView;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_loading_screen);

        PBar = findViewById(R.id.progressBar);
        PBar.setMax(100);
        PBar.setProgress(0);

        Thread thread = new Thread() {
            public void run() {
                try {
                    for (int i = 0; i < 100; i++) {
                        PBar.setProgress(i);
                        sleep(30);
                    }

                } catch(Exception exception) {
                    exception.printStackTrace();

                } finally {
                    Intent intent = new Intent(getApplicationContext(), homeScreen.class);
                    startActivity(intent);
                    finish();

                }
            }

        };
        thread.start();
    }

    protected File doInBackground(Void...Voids) {

        String input = null;
        File test = new File(input);

        try{
            FileInputStream fileInput = new FileInputStream(test);
            BufferedInputStream stream = new BufferedInputStream(fileInput);
            ByteArrayOutputStream out = new ByteArrayOutputStream();

            int inputNum = stream.read();
            int ticker = 0;

            while(inputNum != -1){
                ticker++;

                if(ticker%100 == 0){
                    publishProgress(out.size());
                }

                out.write(inputNum);
                inputNum = stream.read();
            }

            FileOutputStream OutStream = new FileOutputStream(test);

        }
        catch(FileNotFoundException e){

        }
        catch(IOException e){

        }
        return null;
    }

    private void publishProgress(int size) {
        Thread thread = new Thread() {
            public void run() {
                try {
                    for (int i = 0; i < 100; i++) {
                        PBar.setProgress(i);
                        sleep(30);
                    }

                } catch(Exception exception) {
                    exception.printStackTrace();

                } finally {
                    Intent intent = new Intent(getApplicationContext(), homeScreen.class);
                    startActivity(intent);
                    finish();

                }
            }

        };
        thread.start();
    }

    protected void onStart() {
        spotifyClass = new SpotifyClass();

        super.onStart();
        LogIn();
    }

    protected void onStop() {
        super.onStop();
        //SpotifyAppRemote.disconnect(spotifyClass.mSpotifyAppRemote);
    }

    /*
     * log into spotify using the spotify app logged in on the phone
     */
    public void LogIn() {
        AuthenticationRequest.Builder builder = new AuthenticationRequest.Builder(spotifyClass.CLIENT_ID, AuthenticationResponse.Type.TOKEN, spotifyClass.REDIRECT_URI);
        builder.setScopes(new String[]{"streaming"});
        AuthenticationRequest request = builder.build();
        AuthenticationClient.openLoginActivity(this, REQUEST_CODE, request);

        ConnectionParams connP = new ConnectionParams.Builder(spotifyClass.CLIENT_ID).setRedirectUri(spotifyClass.REDIRECT_URI).showAuthView(true).build();

        SpotifyAppRemote.connect(this, connP, new Connector.ConnectionListener() {
            public void onConnected(SpotifyAppRemote spotifyAppRemote) {
                spotifyClass.mSpotifyAppRemote = spotifyAppRemote;
                Toast.makeText(MainActivity.this,"Connected to Spotify", Toast.LENGTH_LONG).show();
                Log.d("Testing!!!", "Connected");

                connected();
            }

            public void onFailure(Throwable throwable) {
                Toast.makeText(MainActivity.this,"Not Connected to Spotify", Toast.LENGTH_LONG).show();
                Log.e("Testing!!!", throwable.getMessage(), throwable);
                //Something went wrong when attempting to connect! Handle errors here
            }
        });
    }

    /*
     * this method is run when the app connects to spotify
     */
    public void connected(){
    }

    protected void onActivityResult(int requestCode, int resultCode, Intent intent) {
        super.onActivityResult(requestCode, resultCode, intent);

        // Check if result comes from the correct activity
        if (requestCode == REQUEST_CODE) {
            AuthenticationResponse response = AuthenticationClient.getResponse(resultCode, intent);

            switch (response.getType()) {
                // Response was successful and contains auth token
                case TOKEN:
                    // Handle successful response
                    break;

                // Auth flow returned an error
                case ERROR:
                    // Handle error response
                    break;

                // Most likely auth flow was cancelled
                default:
                    // Handle other cases
            }
        }
    }
}
