package com.example.soulfood_assignment2;

import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.os.Bundle;
import android.support.v7.app.AppCompatActivity;
import android.util.Log;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.ListView;
import android.widget.Toast;

import java.util.ArrayList;
import java.util.Set;

public class SavedPlaylists extends AppCompatActivity {

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_saved_playlists);
        SharedPreferences playlists = getApplicationContext().getSharedPreferences("Saves", 0);

        Set<String> playlistTags = playlists.getStringSet("saves", null);
        ArrayList<String> saved = new ArrayList<String>();

        for(String s : playlistTags){
            String[] stringParts = s.split(" ");
            String message = "Playlist_for_cuisine: " + stringParts[0] + " ,time: " + stringParts[1] + " ,vibe: " + stringParts[2];
            saved.add(message);
        }

        ListView listView = findViewById(R.id.listViewPlaylists);

        ArrayAdapter<String> adapter = new ArrayAdapter<>(this, android.R.layout.simple_list_item_1, saved);
        listView.setAdapter(adapter);

        listView.setOnItemClickListener(new AdapterView.OnItemClickListener() {

            @Override
            public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
                String item = listView.getItemAtPosition(position).toString();
                String[] itemParts = item.split(" ");
                buildPlaylistOnClick(view, itemParts[5], itemParts[1], itemParts[3]);
            }
        });
    }

    public void buildPlaylistOnClick(View view, String vibe, String cuisine, String timeOfDay) {
        Intent intent = new Intent(this, playlistView.class);
        intent.putExtra("vibe", vibe);
        intent.putExtra("cuisine", cuisine);
        intent.putExtra("timeofday", timeOfDay);
        startActivity(intent);
    }
}
