package com.example.soulfood_assignment2;

import android.content.Intent;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.Spinner;

import java.lang.reflect.Array;
import java.util.ArrayList;

import static com.example.soulfood_assignment2.databaseInterface.Cuisine.american;
import static com.example.soulfood_assignment2.databaseInterface.Cuisine.any;
import static com.example.soulfood_assignment2.databaseInterface.Cuisine.chinese;
import static com.example.soulfood_assignment2.databaseInterface.Cuisine.french;
import static com.example.soulfood_assignment2.databaseInterface.Cuisine.indian;
import static com.example.soulfood_assignment2.databaseInterface.Cuisine.italian;
import static com.example.soulfood_assignment2.databaseInterface.Cuisine.thai;
import static com.example.soulfood_assignment2.databaseInterface.Vibe.calming;
import static com.example.soulfood_assignment2.databaseInterface.Vibe.chill;
import static com.example.soulfood_assignment2.databaseInterface.Vibe.energetic;

public class build_playlist extends AppCompatActivity {

    String vibe;
    String cuisine;
    String timeOfDay;

    databaseInterface.Cuisine cuisineTag;
    databaseInterface.Vibe vibeTag;
    databaseInterface.Time timeTag;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.build_playlist);

        ArrayList<String> vibes = new ArrayList<>();
        vibes.add("any");
        vibes.add("chilled");
        vibes.add("energetic");
        vibes.add("relaxing");
        Spinner vibesSpinner = findViewById(R.id.vibe_dropdown);
        ArrayAdapter<String> vibesAdapter = new ArrayAdapter<String>(this, android.R.layout.simple_spinner_dropdown_item, vibes);
        vibesSpinner.setAdapter(vibesAdapter);

        vibesSpinner.setOnItemSelectedListener(new AdapterView.OnItemSelectedListener() {

            @Override
            public void onItemSelected(AdapterView<?> arg0, View arg1, int position, long arg3) {
                vibe = vibes.get(position);
            }

            @Override
            public void onNothingSelected(AdapterView<?> arg0) {

            }
        });

        ArrayList<String> cuisines = new ArrayList<>();
        cuisines.add("any");
        cuisines.add("chinese");
        cuisines.add("thai");
        cuisines.add("indian");
        cuisines.add("italian");
        cuisines.add("american");
        cuisines.add("french");
        cuisines.add("spanish");
        Spinner cuisineSpinner = findViewById(R.id.cuisine_dropdown);
        ArrayAdapter<String> cuisineAdapter = new ArrayAdapter<String>(this, android.R.layout.simple_spinner_dropdown_item, cuisines);
        cuisineSpinner.setAdapter(cuisineAdapter);

        cuisineSpinner.setOnItemSelectedListener(new AdapterView.OnItemSelectedListener() {

            @Override
            public void onItemSelected(AdapterView<?> arg0, View arg1, int position, long arg3) {
                cuisine = cuisines.get(position);
            }

            @Override
            public void onNothingSelected(AdapterView<?> arg0) {

            }
        });

        ArrayList<String> timeOfDays = new ArrayList<>();
        timeOfDays.add("any");
        timeOfDays.add("breakfast");
        timeOfDays.add("lunch");
        timeOfDays.add("dinner");
        Spinner timeOfDaySpinner = findViewById(R.id.tod_dropdown);
        ArrayAdapter<String> timeOfDayAdapter = new ArrayAdapter<String>(this, android.R.layout.simple_spinner_dropdown_item, timeOfDays);
        timeOfDaySpinner.setAdapter(timeOfDayAdapter);

        timeOfDaySpinner.setOnItemSelectedListener(new AdapterView.OnItemSelectedListener() {

            @Override
            public void onItemSelected(AdapterView<?> arg0, View arg1, int position, long arg3) {
                timeOfDay = timeOfDays.get(position);
            }

            @Override
            public void onNothingSelected(AdapterView<?> arg0) {

            }
        });


    }

    public void buildPlaylistOnClick(View view) {
        Intent intent = new Intent(this, playlistView.class);
        intent.putExtra("vibe", vibe);
        intent.putExtra("cuisine", cuisine);
        intent.putExtra("timeofday", timeOfDay);
        startActivity(intent);
    }

    public void homeScreenViewOnClick(View view) {
        Intent intent = new Intent(this, homeScreen.class);
        startActivity(intent);
    }


}

