package com.example.soulfood_assignment2;

import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.widget.Button;
import android.widget.ListView;

import java.util.ArrayList;

import static com.example.soulfood_assignment2.databaseInterface.Cuisine.american;
import static com.example.soulfood_assignment2.databaseInterface.Cuisine.any;
import static com.example.soulfood_assignment2.databaseInterface.Cuisine.chinese;
import static com.example.soulfood_assignment2.databaseInterface.Cuisine.french;
import static com.example.soulfood_assignment2.databaseInterface.Cuisine.indian;
import static com.example.soulfood_assignment2.databaseInterface.Cuisine.italian;
import static com.example.soulfood_assignment2.databaseInterface.Cuisine.thai;
import static com.example.soulfood_assignment2.databaseInterface.Time.breakfast;
import static com.example.soulfood_assignment2.databaseInterface.Time.dinner;
import static com.example.soulfood_assignment2.databaseInterface.Time.lunch;
import static com.example.soulfood_assignment2.databaseInterface.Vibe.calming;
import static com.example.soulfood_assignment2.databaseInterface.Vibe.chill;
import static com.example.soulfood_assignment2.databaseInterface.Vibe.energetic;

public class playlistView extends AppCompatActivity {

    databaseInterface.Cuisine cuisineTag;
    databaseInterface.Vibe vibeTag;
    databaseInterface.Time timeTag;

    ListView playlistView;

    String cuisine;
    String vibe;
    String timeOfDay;

    String anyVibe = "any";
    String anyTime = "any";
    String anyCuisine = "any";

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_playlist_view);

        cuisine = getIntent().getStringExtra("cuisine");

        vibe = getIntent().getStringExtra("vibe");

        timeOfDay = getIntent().getStringExtra("timeofday");

        if(cuisine == null) {
            cuisineTag = any;
        } else if(cuisine.equalsIgnoreCase(anyCuisine)) {
            cuisineTag = any;
        } else if(cuisine.equalsIgnoreCase("chinese")) {
            cuisineTag = chinese;
        } else if(cuisine.equalsIgnoreCase("thai")) {
            cuisineTag = thai;
        } else if(cuisine.equalsIgnoreCase("indian")) {
            cuisineTag = indian;
        } else if(cuisine.equalsIgnoreCase("italian")) {
            cuisineTag = italian;
        } else if(cuisine.equalsIgnoreCase("american")) {
            cuisineTag = american;
        } else if(cuisine.equalsIgnoreCase("french")) {
            cuisineTag = french;
        }

        if(vibe == null) {
            vibeTag = databaseInterface.Vibe.any;
        } else if(vibe.equalsIgnoreCase(anyVibe)) {
            vibeTag = databaseInterface.Vibe.any;
        } else if(vibe.equalsIgnoreCase("chilled")) {
            vibeTag = chill;
        } else if(vibe.equalsIgnoreCase("energetic")) {
            vibeTag = energetic;
        } else if(vibe.equalsIgnoreCase("relaxing")) {
            vibeTag = calming;
        }

        if(timeOfDay == null) {
            timeTag = databaseInterface.Time.any;
        } else if(timeOfDay.equalsIgnoreCase(anyTime)) {
            timeTag = databaseInterface.Time.any;
        } else if(timeOfDay.equalsIgnoreCase("breakfast")) {
            timeTag = breakfast;
        } else if(timeOfDay.equalsIgnoreCase("lunch")) {
            timeTag = lunch;
        } else if(timeOfDay.equalsIgnoreCase("dinner")) {
            timeTag = dinner;
        }

        ThaiAsyncTask thaiAsyncTask = new ThaiAsyncTask(this, cuisineTag, timeTag, vibeTag);
        thaiAsyncTask.listView = findViewById(R.id.playlistView);
        thaiAsyncTask.execute();
        playlistView = thaiAsyncTask.listView;
        
        playlistView.setOnItemClickListener(new AdapterView.OnItemClickListener() {
            @Override
            public void onItemClick(AdapterView<?> arg0, View v, int position, long arg3) {
                Intent intent = new Intent(playlistView.getContext(), SongInformationPage.class);
                intent.putExtra("song_name", playlistView.getItemAtPosition(position).toString());
                intent.putExtra("tag1_name", cuisine);
                intent.putExtra("tag2_name", timeOfDay);
                intent.putExtra("tag3_name", vibe);
                startActivity(intent);
            }
        });

        Button save = (Button)findViewById(R.id.saveButton);
        //save.setOnClickListener(save()); //when the button is pressed save should be implemeted
                                        // but unfortunately i cant find the array list to put in
    }

    /*
     needs an array list of songs
     saves them in the databasee as a new playlist
     saves the playlist as a shared preference
     hopefully
     */
    private void save(ArrayList<String> songs) {
        databaseInterface dbi = new databaseInterface(); // so we can use database methods
       // String id = dbi.savePlaylist(songs); // save in the database, hopefully
                                            // that method returns the saved id so we can put it in the shared preference

        SavedPlaylists savedPlaylists = new SavedPlaylists(); //so we can save in the shared preference
       // savedPlaylists.savePlaylist(id); // saves as a shared preference
    }

}
