package com.example.soulfood_assignment2;

import android.content.Intent;
import android.os.Bundle;
import android.support.v7.app.AppCompatActivity;
import android.util.Log;
import android.view.Menu;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.ListView;
import android.widget.SearchView;
import android.widget.Toast;

import java.util.ArrayList;
import java.util.Arrays;

public class searchScreen extends AppCompatActivity {

    public ListView searchResults;
    public ListView songResults;
    public ArrayAdapter<String> adapter;

    public Intent vibeView;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_search_screen);
        searchResults = findViewById(R.id.tagListView);
        songResults = findViewById(R.id.charleyNeedsHelp);

        ArrayList<String> searchResultsArray = new ArrayList<>();
        searchResultsArray.addAll(Arrays.asList(getResources().getStringArray(R.array.searchResultsArray)));

        adapter = new ArrayAdapter<String>(
                searchScreen.this, android.R.layout.simple_list_item_1, searchResultsArray
        );

        searchResults.setAdapter(adapter);
        searchResults.setOnItemClickListener(new AdapterView.OnItemClickListener() {

            @Override
            public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
                switch (position) {
                    case 0:
                        buildPlaylistOnClick(view, "any", "chinese", "any");
                        break;
                    case 1:
                        buildPlaylistOnClick(view, "any", "thai", "any");
                        break;
                    case 2:
                        buildPlaylistOnClick(view, "any", "indian", "any");
                        break;
                    case 3:
                        buildPlaylistOnClick(view, "any", "japanese", "any");
                        break;
                    case 4:
                        buildPlaylistOnClick(view, "any", "italian", "any");
                        break;
                    case 5:
                        buildPlaylistOnClick(view, "any", "mexican", "any");
                        break;
                    case 6:
                        buildPlaylistOnClick(view, "any", "french", "any");
                        break;
                    case 7:
                        buildPlaylistOnClick(view, "any", "american", "any");
                        break;
                    case 8:
                        buildPlaylistOnClick(view, "chill", "any", "any");
                        break;
                    case 9:
                        buildPlaylistOnClick(view, "happy", "any", "any");
                        break;
                    case 10:
                        buildPlaylistOnClick(view, "energetic", "any", "any");
                        break;
                }
            }


        });


    }

    public void buildPlaylistOnClick(View view, String vibe, String cuisine, String timeOfDay) {
        Intent intent = new Intent(this, playlistView.class);
        intent.putExtra("vibe", vibe);
        intent.putExtra("cuisine", cuisine);
        intent.putExtra("timeofday", timeOfDay);
        startActivity(intent);
    }

    public boolean onCreateOptionsMenu(Menu menu) {

        SearchView sv = findViewById(R.id.searchView);
        sv.setQueryHint("Search for tags");

        sv.setOnQueryTextListener(new SearchView.OnQueryTextListener() {
            @Override
            public boolean onQueryTextSubmit(String s) {

                Toast.makeText(searchScreen.this,"No tags to match this result.", Toast.LENGTH_LONG).show();
                return false;
            }

            @Override
            public boolean onQueryTextChange(String s) {
                adapter.getFilter().filter(s);
                return false;
            }
        });

        return super.onCreateOptionsMenu(menu);

    }

    public void homeScreenViewOnClick(View view) {
        Intent intent = new Intent(this, homeScreen.class);
        startActivity(intent);
    }


}
